Attribute VB_Name = "Shots_Module"
Option Explicit

' shot structure definition
Public Type shot
 Exist As Boolean       ' exists?
 
 pos As vector          ' position vector
 opos As vector         ' old position vector
 velocity As vector     ' velocity vector
 
 parent As Integer      ' who shot it?
 
 age As Integer         ' rob age
 nrg As Single          ' energy carrier
 range As Single        ' shot range (the maximum .nrg ever was)
 value As Integer       ' power of shot for negative shots (or amt of shot, etc.), value to write for > 0
 
 color As Long          ' colour
 shottype As Integer    ' carried location/value couple
 
 fromveg As Boolean     ' does shot come from veg?
 FromSpecie As String   ' Which species fired the shot
 
 Memloc As Integer      ' Memory location for custom poison and venom
 Memval As Integer      ' Value to insert into custom venom location
 
 DNA() As block         ' Somewhere to store genetic code for a virus
 genenum As Integer     ' which gene to copy in host bot
 stored As Boolean      ' for virus shots (and maybe future types) this shot is stored
                        ' inside the bot until it's ready to be launched
End Type

Public Shots() As shot  ' array of shots
Public maxshots As Integer
Dim maxshotarray As Long
Const shotdecay As Integer = 40 'increase to have shots lose power slower
Const ShellEffectiveness As Integer = 20 'how strong each unit of shell is
Const SlimeEffectiveness As Integer = 20 'how strong each unit of slime is against viruses

'
'   S H O T S   M A N A G E M E N T
'

' calculates the half brightness of a colour
' for a vaguely shiny effect in particles burst
Private Function HBrite(ByVal col As Long) As Long
  Dim b As Integer, g As Integer, r As Integer
  b = Int(col / 65536)
  col = col - (b * 65536)
  g = Int(col / 256)
  r = col - (g * 256)
  b = b / 2
  g = g / 2
  r = r / 2
  HBrite = RGB(r, g, b)
End Function

' same, but doubles
Public Function DBrite(ByVal col As Long) As Long
  Dim b As Long, g As Long, r As Long
  b = Int(col / 65536)
  col = col - (b * 65536)
  g = Int(col / 256)
  r = col - (g * 256)
  b = b + (255 - b) / 2
  g = g + (255 - g) / 2
  r = r + (255 - r) / 2
  DBrite = RGB(r, g, b)
End Function

' creates a shot shooted by robot n, with couple location/value
' returns the shot num of the shot
Public Function newshot(n As Integer, ByVal shottype As Integer, ByVal val As Long, rngmultiplier As Single) As Integer
  Dim A As Integer
  Dim ran As Single
  Dim angle As vector
  Dim ShAngle As Single
  
  If IsArrayBounded(Shots) = False Then
    ReDim Shots(300)
    maxshotarray = 300
  End If
  
  A = FirstSlot
  If A > maxshotarray Then
    maxshotarray = maxshotarray + 1
    ReDim Preserve Shots(maxshotarray)
  End If
  
  Shots(A).Exist = True
  Shots(A).age = 0
  Shots(A).parent = n
  Shots(A).FromSpecie = rob(n).fname    'Which species fired the shot
  Shots(A).fromveg = rob(n).Veg 'does shot come from a veg or not?
  Shots(A).color = rob(n).color
  If shottype = -2 Then Shots(A).color = vbWhite
  Shots(A).value = val
  Shots(A).shottype = shottype
  Shots(A).Memloc = rob(n).mem(835)     'location for venom to target
  If Shots(A).Memloc < 1 Then Shots(A).Memloc = ((Shots(A).Memloc - 1) Mod 1000) + 1
  If Shots(A).Memloc > 1000 Then Shots(A).Memloc = ((Shots(A).Memloc - 1) Mod 1000) + 1
  Shots(A).Memval = rob(n).mem(836)     'value to insert into venom target location
  
  If val > 32000 Then val = 32000
  ran = Random(-2, 2) / 20
  
  If rob(n).mem(backshot) = 0 Then
    ShAngle = rob(n).aim        'forward shots
  Else
    ShAngle = angnorm(rob(n).aim - PI) 'backward shots
    rob(n).mem(backshot) = 0
  End If
  
  If rob(n).mem(aimshoot) <> 0 Then '0 is the same as .shoot without any aiming
    rob(n).mem(aimshoot) = rob(n).mem(aimshoot) Mod 1256
    
    ShAngle = (rob(n).aim - rob(n).mem(aimshoot) / 200)
    rob(n).mem(aimshoot) = 0
  End If
  
  angle = VectorSet(Cos(ShAngle), -Sin(ShAngle))
  Shots(A).pos = VectorAdd(rob(n).pos, VectorScalar(angle, rob(n).radius))
  Shots(A).velocity = VectorAdd(rob(n).vel, VectorScalar(angle, RobSize / 3))
  
  Shots(A).opos = VectorSub(Shots(A).pos, Shots(A).velocity)
  
  If rob(n).vbody > 10 Then
    Shots(A).nrg = Log(Abs(rob(n).vbody)) * 60 * rngmultiplier
    Dim temp As Long
    temp = (Shots(A).nrg + (RobSize \ 3) + 1) \ (RobSize / 3) 'divides and rounds up
    Shots(A).range = temp
    Shots(A).nrg = temp * (RobSize / 3)
  Else
    Shots(A).range = rngmultiplier
    Shots(A).nrg = (RobSize / 3) * rngmultiplier
  End If
  
  'return the new shot
  newshot = A
  
  If shottype = -7 Then
    Shots(A).color = vbCyan
    Shots(A).genenum = val
    Shots(A).stored = True
    If Not copygene(A, Shots(A).genenum) Then
      Shots(A).Exist = False
      newshot = -1
    End If
  Else
    Shots(A).stored = False
  End If
End Function

' creates a generic particle with arbitrary x & y, vx & vy, etc
Public Sub createshot(ByVal x As Long, ByVal y As Long, ByVal vx As Integer, _
  ByVal vy As Integer, loc As Integer, par As Integer, val As Long, _
  range As Single, col As Long)
  Dim A As Integer
  
  If IsArrayBounded(Shots) = False Then
    ReDim Shots(300)
    maxshotarray = 300
  End If
  
  A = FirstSlot
  If A > UBound(Shots) Then
    maxshotarray = maxshotarray + 100
    ReDim Preserve Shots(maxshotarray)
  End If
  Shots(A).parent = par
  Shots(A).FromSpecie = rob(par).fname
  Shots(A).fromveg = rob(par).Veg
  
  Shots(A).pos.x = x '+ vx
  Shots(A).pos.y = y '+ vy
  Shots(A).velocity.x = vx
  Shots(A).velocity.y = vy
  Shots(A).opos = VectorSub(Shots(A).pos, Shots(A).velocity)
    
  Shots(A).age = 0
  Shots(A).color = col
  Shots(A).Exist = True
    
  Dim temp As Long
  temp = (range + (RobSize \ 3) + 1) \ (RobSize \ 3) 'divides and rounds up ie: range / (Robsize/3)
  
  Shots(A).nrg = temp * (RobSize / 3)
  Shots(A).range = temp
  Shots(A).value = val
  Shots(A).shottype = loc
  Shots(A).Memloc = rob(par).mem(834)
  If Shots(A).Memloc < 0 Then Shots(A).Memloc = 0
  If Shots(A).Memloc > 1000 Then Shots(A).Memloc = 1000
  
End Sub

' searches some place to insert the new shot in the
' shots array.
Private Function FirstSlot() As Integer
  
  FirstSlot = 1
  While Shots(FirstSlot).Exist
    FirstSlot = FirstSlot + 1
    If FirstSlot > maxshotarray Then GoTo exitloop
  Wend
exitloop:
  If FirstSlot > maxshots Then maxshots = FirstSlot
End Function

' calculates next shots position
Public Sub updateshots()
'moves shot then checks for collision

  Dim t As Integer
  Dim h As Integer
  Dim dx As Integer
  Dim sx As Integer
  Dim rp As Integer
  Dim jj As Integer
  Dim ti As Single
  Dim x As Long
  Dim y As Long
  Dim onrg As Long
  For t = 1 To maxshots
    With Shots(t)
      If .Exist Then
      
        .opos = .pos
        .pos = VectorAdd(.pos, .velocity) 'Euler integration
        
        If Not SimOpts.Updnconnected Then
          If .pos.y < 0 Then .pos.y = 0: .velocity.y = -.velocity.y
          If .pos.y > SimOpts.FieldHeight Then .pos.y = SimOpts.FieldHeight: .velocity.y = -.velocity.y
        End If
        
        If Not SimOpts.Dxsxconnected Then
          If .pos.x < 0 Then .pos.x = 0: .velocity.x = -.velocity.x
          If .pos.x > SimOpts.FieldWidth Then .pos.x = SimOpts.FieldWidth: .velocity.x = -.velocity.x
        End If
        
        .age = .age + 1
        
        If .age > .range Then
          .Exist = False
          h = 0
        Else
          h = ShotColl(t)
        End If
        
        If h > 0 Then
          If .parent = rob(h).parent And rob(h).age <= 1 Then GoTo exitif
          'babies born into a stream of shots from its parent shouldn't die
          'from those shots.  I can't imagine this temporary imunity can be
          'exploited, so it should be safe
          
          'this below is horribly complicated:  allow me to explain:
          'We find the average nrg between where the shot is now and where it was
          'nrg dissipates in a non-linear fashion.  Very little nrg disappears until you
          'get near the last 10% of the journey or so.
          
          .nrg = .nrg / 2 / Atn(-shotdecay)
          .nrg = .nrg * (Atn(.age / .range * shotdecay - shotdecay) + _
                         Atn((.age - 1) * .range * shotdecay - shotdecay))
          
          .Exist = False
          If .shottype > 0 Then
            If .shottype <> DelgeneSys Then
              Dim power As Long
              If .shottype = 312 Or .shottype = 313 Or _
                .shottype = 824 Or .shottype = 826 And _
                .value > 100 Then .value = 100
                
              If .nrg / 2 > rob(h).poison Then
                rob(h).mem(.shottype) = .value
              Else
                createshot Shots(t).pos.x, Shots(t).pos.y, -.velocity.x, -.velocity.y, -5, h, .nrg / 2, Shots(t).range * RobSize / 3, vbYellow
                rob(h).poison = rob(h).poison - (.nrg / 2) * 0.9
                rob(h).Waste = rob(h).Waste + (.nrg / 2) * 0.1
                If rob(h).poison < 0 Then rob(h).poison = 0
                rob(h).mem(poison) = rob(h).poison
              End If
            End If
          Else
            Select Case .shottype
              Case -1 'shot might just rip through this bot, and continue on
                'note: may return the shot with .exist = true
                releasenrg h, t
              Case -2: takenrg h, t
              Case -3: takeven h, t
              Case -4: takewaste h, t
              Case -5: takepoison h, t
              Case -6 'shot might just rip through this bot, and continue on
                'note: may return the shot with .exist = true
                releasebod h, t
              Case -7: addgene h, t
            End Select
            
          End If
          taste h, .opos.x, .opos.y, .shottype
        End If
exitif:
      End If
    End With
  Next t
End Sub

Public Sub Decay(n As Integer) 'corpse decaying as waste shot, energy shot or no shot
  Dim sh As Integer
  Dim va As Long
  rob(n).DecayTimer = rob(n).DecayTimer + 1
  If rob(n).DecayTimer >= SimOpts.Decaydelay Then
    rob(n).DecayTimer = 0
    
    If SimOpts.DecayType = 2 Then
      sh = -4
      va = SimOpts.Decay
      newshot n, sh, va, 1
    End If
    
    If SimOpts.DecayType = 3 Then
      sh = -2
      va = SimOpts.Decay
      newshot n, sh, va, 1
    End If
    
    rob(n).aim = Rnd * 2 * PI
    rob(n).aimvector = VectorSet(Cos(rob(n).aim), Sin(rob(n).aim))
    rob(n).BODY = rob(n).BODY - SimOpts.Decay / 10
    rob(n).radius = FindRadius(rob(n).BODY)
  End If
End Sub
Public Sub defacate(n As Integer) 'only used to get rid of massive amounts of waste
  Dim sh As Integer
  Dim va As Long
  sh = -4
  va = 200
  
  If va > rob(n).Waste Then va = rob(n).Waste
  If rob(n).Waste > 32000 Then rob(n).Waste = 31500: va = 500
  
  rob(n).Waste = rob(n).Waste - va
  rob(n).nrg = rob(n).nrg - SimOpts.Costs(SHOTCOST) / (rob(n).Numties + 1)
  newshot n, sh, va, 1
  rob(n).Pwaste = rob(n).Pwaste + va / 1000
End Sub

' robot n, hit by shot t, releases energy
Public Sub releasenrg(n As Integer, t As Integer)
  'n=robot number
  't=shot number
  Dim vel As vector
  
  Dim vs As Integer
  Dim vr As Single
  Dim power As Long
  Dim range As Single
  Dim scalingfactor As Single
  Dim Newangle As Single
      
  vel = VectorScalar(VectorSub(rob(n).vel, Shots(t).velocity), 0.5) 'half the relative velocity of
                                                                     'the shot to the hit bot
  vel = VectorAdd(vel, rob(n).vel) 'then add in the velocity of hit robot
  
  If SimOpts.EnergyExType Then
    power = Shots(t).value * Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * SimOpts.EnergyProp
  Else
    power = SimOpts.EnergyFix
  End If
  
  If power > (rob(n).nrg / 0.9 + rob(n).poison) And Not rob(n).Corpse Then
    'shot will continue on past this bot since it wasn't all used up.
  
    'with reduced impact
    Shots(t).value = (power - rob(n).nrg / 0.9 - rob(n).poison) * Shots(t).range / (Shots(t).age * SimOpts.EnergyProp)
    Shots(t).nrg = Shots(t).range * (RobSize \ 3)
    power = rob(n).nrg / 0.9 + rob(n).poison
    Shots(t).Exist = True
  End If
  
  If rob(n).Corpse Then power = power * 0.5 'half power against corpses.  Most of your shot is wasted
  
  range = Shots(t).range     'returned energy shots have the same range as the shot that it came from
  
  If rob(n).poison > power Then 'create poison shot
    createshot Shots(t).pos.x, Shots(t).pos.y, vel.x, vel.y, -5, n, power, range * (RobSize / 3), vbYellow
    rob(n).Waste = rob(n).Waste + (power * 0.1)
    rob(n).poison = rob(n).poison - (power * 0.9)
    If rob(n).poison < 0 Then rob(n).poison = 0
    rob(n).mem(poison) = rob(n).poison
  Else ' create energy shot
    createshot Shots(t).pos.x, Shots(t).pos.y, vel.x, vel.y, -2, n, power, range * (RobSize / 3), vbWhite
    rob(n).nrg = rob(n).nrg - power * 0.9  'some of shot comes from nrg
    rob(n).BODY = rob(n).BODY - power * 0.01 'some of shot comes from body
    rob(n).radius = FindRadius(rob(n).BODY)
  End If
  
  If rob(n).BODY < 0 Or rob(n).nrg < 0 Then
    rob(Shots(t).parent).Kills = rob(Shots(t).parent).Kills + 1
    rob(Shots(t).parent).mem(220) = rob(Shots(t).parent).Kills
  End If
End Sub
Private Sub releasebod(n As Integer, t As Integer) 'a robot is shot by a -6 shot and releases energy directly from body points
  'much more effective against a corpse
  Dim vel As vector
  Dim range As Single
  Dim power As Long
  Dim Shell As Long
  
  vel = VectorScalar(VectorSub(rob(n).vel, Shots(t).velocity), 0.5) 'half the relative velocity of
                                                                     'the shot to the hit bot
  vel = VectorAdd(vel, rob(n).vel) 'then add in the velocity of hit robot
  
  If SimOpts.EnergyExType Then
    power = Shots(t).value * Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * SimOpts.EnergyProp
  Else
    power = SimOpts.EnergyFix
  End If
  
  Shell = rob(n).Shell * ShellEffectiveness
  
  If power > ((rob(n).BODY * 10) / 0.8 + Shell) And Not rob(n).Corpse Then
    'shot will continue on past this bot since it wasn't all used up.
  
    'with reduced impact
    Shots(t).value = (power - (rob(n).BODY * 10) / 0.8 + Shell) * Shots(t).range / (Shots(t).age * SimOpts.EnergyProp)
    Shots(t).nrg = Shots(t).range * (RobSize \ 3)
    power = (rob(n).BODY * 10) / 0.8 + Shell
    Shots(t).Exist = True
  End If
  
  If power < Shell Then
    rob(n).Shell = rob(n).Shell - power / ShellEffectiveness
    If rob(n).Shell < 0 Then rob(n).Shell = 0
    Exit Sub
  Else
    rob(n).Shell = rob(n).Shell - power / ShellEffectiveness
    If rob(n).Shell < 0 Then rob(n).Shell = 0
    power = power - Shell
  End If
  
  If power <= 0 Then Exit Sub
  
  range = Shots(t).range      'new range formula based on range of incoming shot
  
  ' create energy shot
  If rob(n).Corpse = True Then
    power = power * 4 'So effective against corpses it makes me siiiiiinnnnnggg
    If power > rob(n).BODY * 10 Then power = rob(n).BODY * 10
    rob(n).BODY = rob(n).BODY - power / 10      'all energy comes from body
    rob(n).radius = FindRadius(rob(n).BODY)
  Else
    Dim leftover As Long
    
    rob(n).nrg = rob(n).nrg - power * 0.2       'some of shot comes from nrg
    rob(n).BODY = rob(n).BODY - (power * 0.08)  'some of shot comes from body

    leftover = 0
    If rob(n).nrg < 0 Then
      leftover = leftover + (-rob(n).nrg)
      rob(n).nrg = 0
    End If
    If rob(n).BODY < 0 Then
      leftover = leftover + (-rob(n).BODY * 10)
      rob(n).BODY = 0
    End If

    With rob(n)
    If leftover > 0 Then
      If .nrg > 0 And .nrg > leftover Then
        .nrg = .nrg - leftover
        leftover = 0
      ElseIf .nrg > 0 And .nrg < leftover Then
        leftover = leftover - .nrg
        .nrg = 0
      End If

      If .BODY > 0 And .BODY * 10 > leftover Then
        .BODY = .BODY - leftover
        leftover = 0
      ElseIf rob(n).BODY > 0 And rob(n).BODY * 10 < leftover Then
        leftover = leftover - .BODY
        .BODY = 0
      End If
    End If
    End With
    rob(n).radius = FindRadius(rob(n).BODY)
  End If
  
  If rob(n).BODY < 0 Or rob(n).nrg < 0 Then
    rob(n).Dead = True
    rob(Shots(t).parent).Kills = rob(Shots(t).parent).Kills + 1
    rob(Shots(t).parent).mem(220) = rob(Shots(t).parent).Kills
  End If
  
  createshot Shots(t).pos.x, Shots(t).pos.y, vel.x, vel.y, -2, n, power, range * (RobSize / 3), vbWhite
End Sub

' robot n takes the energy carried by shot t
Private Sub takenrg(n As Integer, t As Integer)
  Dim partial As Long
  
  If rob(n).Corpse Then Exit Sub
  
  partial = Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * Shots(t).value
   
  rob(n).nrg = rob(n).nrg + partial * 0.8       'most of energy goes to nrg
  rob(n).BODY = rob(n).BODY + (partial * 0.019) 'a bit goes to body
  rob(n).Waste = rob(n).Waste + partial * 0.01  'tiny amount goes to waste
  If rob(n).nrg > 32000 Then rob(n).nrg = 32000
  If rob(n).BODY > 32000 Then rob(n).BODY = 32000
  Shots(t).Exist = False
  rob(n).radius = FindRadius(rob(n).BODY)
End Sub
'  robot takes a venomous shot and becomes seriously messed up
Private Sub takeven(n As Integer, t As Integer)
  Dim power As Long
  
  power = Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * Shots(t).value
  
  If Shots(t).Memloc = 340 Or power < 1 Then Exit Sub 'protection from delgene attacks
  
  If Shots(t).FromSpecie = rob(n).fname Then   'Robot is imune to venom from his own species
    rob(n).venom = rob(n).venom + power   'Robot absorbs venom fired by conspec
    rob(n).mem(825) = rob(n).venom
  Else
    If power < rob(n).Shell * ShellEffectiveness Then
      rob(n).Shell = rob(n).Shell - power / ShellEffectiveness
    Else
      Dim temp As Long
      temp = power
      power = power - rob(n).Shell * ShellEffectiveness
      rob(n).Shell = rob(n).Shell - temp / ShellEffectiveness
      If rob(n).Shell < 0 Then rob(n).Shell = 0
    End If
    
    If power < 0 Then Exit Sub
    
    rob(n).Paralyzed = True
    rob(n).Paracount = rob(n).Paracount + power
    
    If Shots(t).Memloc > 0 Then
      If Shots(t).Memloc > 1000 Then Shots(t).Memloc = (Shots(t).Memloc - 1) Mod 1000 + 1
      rob(n).Vloc = Shots(t).Memloc
    Else
      rob(n).Vloc = fRnd(1, 1000)
    End If
    
    rob(n).Vval = Shots(t).Memval
  End If
  Shots(t).Exist = False
End Sub
'  Robot n takes shot t and adds its value to his waste reservoir
Private Sub takewaste(n As Integer, t As Integer)
  Dim power As Long
  
  power = Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * Shots(t).value
  If power < 0 Then Exit Sub
  rob(n).Waste = rob(n).Waste + power
  Shots(t).Exist = False
End Sub
' Robot receives poison shot and becomes disorientated
Private Sub takepoison(n As Integer, t As Integer)
  Dim power As Single
  
  power = Shots(t).nrg / (Shots(t).range * (RobSize / 3)) * Shots(t).value
  
  If Shots(t).FromSpecie = rob(n).fname Then    'Robot is imune to poison from his own species
    rob(n).poison = rob(n).poison + power 'Robot absorbs poison fired by conspecs
    If rob(n).poison > 32000 Then rob(n).poison = 32000
    rob(n).mem(827) = rob(n).poison
  Else
    rob(n).Poisoned = True
    rob(n).Poisoncount = rob(n).Poisoncount + power
    If rob(n).Poisoncount > 32000 Then rob(n).Poisoncount = 32000
    If Shots(t).Memloc > 0 Then
      rob(n).Ploc = (Shots(t).Memloc - 1 Mod 1000) + 1
    Else
      rob(n).Ploc = fRnd(1, 1000)
    End If
  End If
  Shots(t).Exist = False
End Sub

' checks the collisions between robots and shots
Private Function ShotColl(n As Integer) As Integer
  Dim nd As node
  Dim vel As vector
    
  Dim dist As Single
  
  With Shots(n)
  
  If .pos.x > SimOpts.FieldWidth Or .pos.x < 0 Or .pos.y > SimOpts.FieldHeight Or .pos.y < 0 Then
    If SimOpts.Updnconnected = True Then
      If .pos.y > SimOpts.FieldHeight Then .pos.y = .pos.y - SimOpts.FieldHeight
      If .pos.y < 0 Then .pos.y = .pos.y + SimOpts.FieldHeight
    Else
      If .pos.y > SimOpts.FieldHeight Or .pos.y < 0 Then .pos.y = .pos.y - .velocity.y
      .velocity.y = -.velocity.y
    End If
    
    If SimOpts.Dxsxconnected = True Then
      If .pos.x > SimOpts.FieldWidth Then .pos.x = .pos.x - SimOpts.FieldWidth
      If .pos.x < 0 Then .pos.x = .pos.x + SimOpts.FieldWidth
    Else
      If .pos.x > SimOpts.FieldWidth Or .pos.x < 0 Then .pos.x = .pos.x - .velocity.x
      .velocity.x = -.velocity.x
    End If
  End If
  
  ShotColl = OldShotColl(n)
  
  'Dim t As Long
  'Dim ab As vector
  'ab = VectorSet(.x - .ox, .y - .oy)
  '
  'For t = 1 To MaxRobs
  '  If ShotBotHit(t, n, ab) Then ShotColl = t
  'Next t
  '
  'ShotColl = BucketShotColl(n)
  End With
End Function

Private Function OldShotColl(n As Integer) As Long
  Dim ab As vector, ac As vector, bc As vector
  Dim MagAB As Single, A As Integer, robnumber As Integer
  Dim PXY As vector
  Dim dist As Single
  
  With Shots(n)
  ab = VectorSub(.pos, .opos)
  MagAB = VectorMagnitudeSquare(ab)
  
  For robnumber = 1 To MaxRobs
    If rob(robnumber).Exist Then
      PXY = rob(robnumber).pos
        
      ac = VectorSub(PXY, .opos)
      bc = VectorSub(PXY, .pos)
        
      'The below looks simple and like it makes no sense.  Trust me, it's accurate,
      'I've checked it twice
      If Dot(ab, ac) <= 0 Then
        'if AB dot AC > 0 then nearest point is point B
        dist = VectorMagnitudeSquare(bc)
      ElseIf Dot(ab, bc) <= 0 Then
        'if AB dot BC < 0 then nearest point is point A
        dist = VectorMagnitudeSquare(ac)
      ElseIf MagAB > 0 Then
        '(AB cross AC)  / ||AB|| = distance
        'square both sides
        dist = Cross(ab, ac) ^ 2 / MagAB
      End If
      
      If dist <= rob(robnumber).radius * rob(robnumber).radius Then
        If Shots(n).parent <> robnumber And rob(robnumber).Wall = False Then
          OldShotColl = robnumber
          Exit Function
        End If
      End If
    End If
  Next robnumber
  End With
End Function

Public Sub Vshoot(n As Integer, thisshot As Integer)
'here we shoot a virus
  
  With rob(n)
    Dim tempa As Single
    tempa = CInt(rob(n).mem(VshootSys)) * CInt(20) '.vshoot * 20
    If tempa > 32000 Then tempa = 32000
    
    Shots(.virusshot).nrg = tempa
    .nrg = .nrg - tempa / 20 * SimOpts.Costs(SHOTCOST)
  End With
  
  With Shots(thisshot)
  Dim ShAngle As Single
    
    ShAngle = fRnd(1, 1256) / 200
    .stored = False
    .pos.x = (rob(n).pos.x + Cos(ShAngle) * rob(n).radius)
    .pos.y = (rob(n).pos.y - Sin(ShAngle) * rob(n).radius)
  
    .velocity.x = absx(ShAngle, RobSize / 3, 0, 0, 0) ' set shot speed x seems to not work well at high bot speeds
    .velocity.y = absy(ShAngle, RobSize / 3, 0, 0, 0) ' set shot speed y
  
    .velocity.x = .velocity.x + rob(n).vel.x
    .velocity.y = .velocity.y + rob(n).vel.y
    
    .opos.x = .pos.x - .velocity.x
    .opos.y = .pos.y - .velocity.y
  End With
End Sub

Public Function MakeVirus(robn As Integer, ByVal gene As Integer) As Boolean
  rob(robn).virusshot = newshot(robn, -7, Int(gene), 1)
  If rob(robn).virusshot > 0 Then
    MakeVirus = True
  Else
    MakeVirus = False
  End If
End Function

' copy gene number p from robot that fired shot n into shot n dna (virus)
Public Function copygene(n As Integer, ByVal p As Integer) As Boolean
  Dim t As Integer
  Dim parent As Integer
  Dim genelen As Integer
  Dim GeneStart As Long
  Dim GeneEnd As Integer
  
  parent = Shots(n).parent
  
  If p > CountGenes(rob(parent).DNA) Or p < 1 Then
    ' target gene is not beyond the DNA bounds
    copygene = False
    Exit Function
  End If
  
  GeneStart = genepos(rob(parent).DNA, p)
  GeneEnd = NextStop(rob(parent).DNA, GeneStart + 1)
  genelen = GeneEnd - GeneStart
  
  If genelen < 0 Then
    copygene = False
    Exit Function
  End If
  
  ReDim Preserve Shots(n).DNA(genelen + 1)
  
  Shots(n).DNA(genelen + 1).tipo = 10
  Shots(n).DNA(genelen + 1).value = 1
  
  For t = 0 To genelen
    Shots(n).DNA(t) = rob(parent).DNA(GeneStart + t)
  Next t
  
  copygene = True
End Function
' adds gene from shot p to robot n dna
Public Function addgene(n As Integer, ByVal p As Integer) As Integer
  Dim t As Integer
  Dim Insert As Integer
  Dim vlen As Integer   'length of the DNA code of the virus
  Dim Position As Integer   'gene position to insert the virus
  Dim power As Long
  
  power = Shots(p).nrg / (Shots(p).range * RobSize / 3) * Shots(p).value
  
  If power < rob(n).Slime * SlimeEffectiveness Then
    rob(n).Slime = rob(n).Slime - power / SlimeEffectiveness
    Exit Function
  Else
    Dim temp As Long
    temp = rob(n).Slime
    
    rob(n).Slime = rob(n).Slime - power / SlimeEffectiveness
    power = power - rob(n).Slime * SlimeEffectiveness
    If rob(n).Slime < 1 Then rob(n).Slime = 1
  End If
  
  Position = fRnd(0, CountGenes(rob(n).DNA))                  'randomize the gene number
  Position = CountGenes(rob(n).DNA)
  If Position = 0 Then
    Insert = 1
  Else
    Insert = NextStop(rob(n).DNA, genepos(rob(n).DNA, Position))
    If Insert > (rob(n).DnaLen - 1) Then Insert = rob(n).DnaLen - 1
  End If
  'insert now points to the space directly after the gene we're adding this after
  
  vlen = DnaLen(Shots(p).DNA())
  
  If MakeSpace(rob(n).DNA, Insert - 1, vlen) Then 'Moves gene back to make space
    For t = Insert To Insert + vlen - 1
      rob(n).DNA(t) = Shots(p).DNA(t - Insert)
    Next t
  End If
  
  makeoccurrlist n
  rob(n).DnaLen = DnaLen(rob(n).DNA())
  rob(n).genenum = CountGenes(rob(n).DNA)
End Function

Private Function IsArrayBounded(ByRef ArrayIn() As shot) As Boolean
On Error Resume Next
IsArrayBounded = (UBound(ArrayIn) >= LBound(ArrayIn))
End Function
